## limesuite 23.10.0

=== debian/changelog ===
limesuite (23.10.0) unstable; urgency=medium

  * Automatically generated changelog entry for building the Osmocom latest feed

 -- Osmocom OBS scripts <info@osmocom.org>  Thu, 02 Nov 2023 12:36:49 +0000

limesuite (23.10.0-1) unstable; urgency=low

  * Release 23.10.0 (2023-10-23)

 -- Lime Microsystems <apps@limemicro.com>  Sat, 15 Oct 2022 16:30:00 +0100

=== debian/control ===
Source: limesuite
Section: comm
Priority: optional
Maintainer: Lime Microsystems <apps@limemicro.com>
Build-Depends:
    debhelper (>= 9.0.0),
    cmake (>= 3.1.3),
    libusb-1.0-0-dev,
    libwxgtk3.0-dev | libwxgtk3.0-gtk3-dev | libwxgtk3.2-dev,
    libsoapysdr-dev,
    freeglut3-dev,
    libfltk1.3-dev,
    fluid,
Standards-Version: 4.1.1
Homepage: https://myriadrf.org/projects/lime-suite/
Vcs-Git: https://github.com/myriadrf/LimeSuite.git
Vcs-Browser: https://github.com/myriadrf/LimeSuite.git

Package: liblimesuite23.10-1
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: limesuite-udev, limesuite-images
Description: Lime Suite - shared library
 Lime Suite application software.

Package: liblimesuite-dev
Section: libdevel
Architecture: any
Depends:
    liblimesuite23.10-1 (= ${binary:Version}),
    ${misc:Depends}
Description: Lime Suite - development files
 Lime Suite application software.

Package: limesuite
Section: comm
Architecture: any
Depends:
    liblimesuite23.10-1 (= ${binary:Version}),
    ${shlibs:Depends},
    ${misc:Depends},
    xdg-utils
Description: Lime Suite - Library applications
 Lime Suite application software.

Package: soapysdr-module-lms7
Section: libs
Architecture: all
Pre-Depends: ${misc:Pre-Depends}
Depends: soapysdr0.7-module-lms7, ${misc:Depends}
Description: Lime Suite - SoapySDR bindings metapackage
 Lime Suite application software.

Package: soapysdr0.7-module-lms7
Section: comm
Architecture: any
Multi-Arch: same
Depends:
    liblimesuite23.10-1 (= ${binary:Version}),
    ${shlibs:Depends},
    ${misc:Depends}
Description: Lime Suite - SoapySDR bindings
 Lime Suite application software.

Package: limesuite-udev
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}, udev
Description: Lime Suite - USB rules for udev
 Lime Suite application software.

Package: limesuite-images23.10
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}, wget
Description: Lime Suite - Install firmware and gateware images
 Lime Suite application software.
 .
 This is dummy package that downloads the images from the web.

Package: limesuite-images
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}, limesuite-images23.10
Description: Lime Suite - Install firmware and gateware images
 Lime Suite application software.
 .
 This is an empty dependency package that pulls in the images
 for the default version of Lime Suite.

## limesuite 23.11.0

=== CMakeLists.txt ===
########################################################################
## Create lime-suite project
########################################################################
cmake_minimum_required(VERSION 3.1.3)
set(CMAKE_CONFIGURATION_TYPES "Debug;Release;RelWithDebInfo" CACHE STRING INTERNAL FORCE)
project("LimeSuite")

option(BUILD_SHARED_LIBS "Build the shared library" ON)
option(ENABLE_NEW_GAIN_BEHAVIOUR "Enable new gain functionality" OFF)

#include modules for finding CyAPI
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake/Modules/")

if(POLICY CMP0015)
    cmake_policy(SET CMP0015 NEW)
endif()

if(POLICY CMP0077)
    cmake_policy(SET CMP0077 OLD)
endif()

if(${CMAKE_MAJOR_VERSION} GREATER 2)
    cmake_policy(SET CMP0043 NEW)
endif()

list(FIND CMAKE_CONFIGURATION_TYPES "${CMAKE_BUILD_TYPE}" index)
if (${index} EQUAL -1)
   set(CMAKE_BUILD_TYPE "Release")
endif()

########################################################################
# Gather version information from the changelog
# LIME_SUITE_API_VERSION in VersionInfo.h reflects the major/minor
########################################################################
file(READ "${PROJECT_SOURCE_DIR}/Changelog.txt" changelog_txt)
string(REGEX MATCH "Release ([0-9]+)\\.([0-9]+)\\.([0-9]+) \\(" CHANGELOG_MATCH "${changelog_txt}")
if(NOT CHANGELOG_MATCH)
    message(FATAL_ERROR "Failed to extract version number from Changelog.txt")
endif(NOT CHANGELOG_MATCH)
set(VERSION_MAJOR "${CMAKE_MATCH_1}")
set(VERSION_MINOR "${CMAKE_MATCH_2}")
set(VERSION_PATCH "${CMAKE_MATCH_3}")

# the ABI compatibility number should be incremented when the ABI changes
# the format is to use the same major and minor, but to have an incrementing
# number if there are changes within the major.minor release series
set(LIME_SUITE_SOVER "${VERSION_MAJOR}.${VERSION_MINOR}-1")

# packagers may specify -DLIME_SUITE_EXTVER="foo" to replace the git hash
if (NOT LIME_SUITE_EXTVER)
    include(${PROJECT_SOURCE_DIR}/cmake/GetGitRevisionDescription.cmake)
    get_git_head_revision(GITREFSPEC GITHASH)
    if (GITHASH)
        string(SUBSTRING "${GITHASH}" 0 8 GITHASH)
        set(LIME_SUITE_EXTVER "g${GITHASH}")
    else (GITHASH)
        set(LIME_SUITE_EXTVER "unknown")
    endif (GITHASH)
endif()

set(LIME_SUITE_LIBVER "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}")
set(LIME_SUITE_VERSION "${LIME_SUITE_LIBVER}-${LIME_SUITE_EXTVER}")
string(TIMESTAMP BUILD_TIMESTAMP "%Y-%m-%d")

#LIME_SUITE_ROOT is compiled into the library to locate the install base.
#By default, the LIME_SUITE_ROOT is set to the CMAKE_INSTALL_PREFIX.
#However users may overload this by specifying -DLIME_SUITE_ROOT=<path>.
set(LIME_SUITE_ROOT "${CMAKE_INSTALL_PREFIX}" CACHE PATH
    "Installation root for lime::getLimeSuiteRoot()")
file(TO_CMAKE_PATH "${LIME_SUITE_ROOT}" LIME_SUITE_ROOT)

########################################################################
## compiler flags
########################################################################

#C++11 is a required language feature for this project
set(CMAKE_CXX_STANDARD 11)

#is this processor x86? set variable X86
if(CMAKE_SYSTEM_PROCESSOR MATCHES "i686.*|i386.*|x86.*|amd64.*|AMD64.*")
    set(X86 TRUE)
else()
    set(X86 FALSE)
endif()

if(CMAKE_SYSTEM_PROCESSOR MATCHES "riscv64")
        set(RV64 TRUE)
else()
        set(RV64 FALSE)
endif()


if(CMAKE_COMPILER_IS_GNUCXX)

    # include module for check_cxx_compiler_flag
    include(CheckCXXCompilerFlag)

    #enable C++11 on older versions of cmake
    if (CMAKE_VERSION VERSION_LESS "3.1")
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x")
    endif()

    #enable warnings in Debug configurations
    if (NOT CMAKE_BUILD_TYPE STREQUAL "Release")
    	add_compile_options(-Wall -Wpedantic)
    endif()

    #symbols are only exported from libraries/modules explicitly
    add_compile_options(-fvisibility=hidden)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility-inlines-hidden")

    #disable gcc caller-saves flag for O2-O3 optimizations
    #workaround fix for gcc 9.3+
    if(CMAKE_BUILD_TYPE STREQUAL "Release" OR CMAKE_BUILD_TYPE STREQUAL "RelWithDebInfo")
        if(CMAKE_CXX_COMPILER_VERSION VERSION_GREATER 9.3 OR 
            CMAKE_CXX_COMPILER_VERSION VERSION_EQUAL 9.9)
            add_compile_options(-fno-caller-saves)
        endif()
    endif()

    #default SIMD configuration uses native build flags
    #when packaging and x86, use sse3 so the binaries work across multiple x86 variants
    if(NOT DEFAULT_SIMD_FLAGS)
        check_cxx_compiler_flag(-march=native COMPILER_SUPPORTS_MARCH_NATIVE)
        if (COMPILER_SUPPORTS_MARCH_NATIVE)
            set(DEFAULT_SIMD_FLAGS "native")
        endif()
    endif()
    if ("${CMAKE_INSTALL_PREFIX}" STREQUAL "/usr" AND X86)
        set(DEFAULT_SIMD_FLAGS "SSE3")
    endif()
    if(RV64)
        set(DEFAULT_SIMD_FLAGS "rv64")
    endif()

    SET(ENABLE_SIMD_FLAGS "${DEFAULT_SIMD_FLAGS}" CACHE STRING "Set compiler SIMD flags")
    SET_PROPERTY(CACHE ENABLE_SIMD_FLAGS PROPERTY STRINGS none native SSE3 SSE4.2 AVX AVX2) 

    if(${ENABLE_SIMD_FLAGS} MATCHES "native")
        add_definitions(-march=native)
        if(X86)
            add_definitions(-mfpmath=both)
        endif()
        message(STATUS "Enabling native optimizations")
    elseif(${ENABLE_SIMD_FLAGS} MATCHES "AVX2")
        add_definitions(-mmmx -msse -msse2 -msse3 -mssse3 -msse4.1 -msse4.2 -mpopcnt -mavx -mfma -mavx2 -mfpmath=both)
        message(STATUS "Enabling AVX2 instructions")
    elseif(${ENABLE_SIMD_FLAGS} MATCHES "AVX")
        add_definitions(-mmmx -msse -msse2 -msse3 -mssse3 -msse4.1 -msse4.2 -mpopcnt -mavx -mfpmath=both)
        message(STATUS "Enabling AVX instructions")
    elseif(${ENABLE_SIMD_FLAGS} MATCHES "SSE4.2")
        add_definitions(-mmmx -msse -msse2 -msse3 -mssse3 -msse4.1 -msse4.2 -mpopcnt -mfpmath=both)
        message(STATUS "Enabling SSE4.2 instructions")
    elseif(${ENABLE_SIMD_FLAGS} MATCHES "SSE3")
        add_definitions(-mmmx -msse -msse2 -msse3 -mfpmath=both)
        message(STATUS "Enabling SSE3 instructions")
    endif()

endif()

if (MSVC)
    include_directories(${PROJECT_SOURCE_DIR}/external/msvc)
    add_definitions(-D_CRT_SECURE_NO_WARNINGS)
    set( MSVC_MULTITHREAD_COMPILE_FLAGS "/MP")
    set( CMAKE_CXX_FLAGS  "${CMAKE_CXX_FLAGS} ${MSVC_MULTITHREAD_COMPILE_FLAGS}" )

    SET(ENABLE_SIMD_FLAGS "SSE2" CACHE STRING "Set compiler SIMD flags")
    SET_PROPERTY(CACHE ENABLE_SIMD_FLAGS PROPERTY STRINGS none SSE2 AVX AVX2) 

    if(${ENABLE_SIMD_FLAGS} MATCHES "AVX2")
        add_definitions(/arch:AVX2)
        message(STATUS "Enabling AVX2 instructions")
    elseif(${ENABLE_SIMD_FLAGS} MATCHES "AVX")
        add_definitions(/arch:AVX)
        message(STATUS "Enabling AVX instructions")
    # MSVC default mode already uses SSE2
    # elseif(${ENABLE_SIMD_FLAGS} MATCHES "SSE2")
    #     add_definitions(/arch:SSE2)
    #     message(STATUS "Enabling SSE2 instructions")
    endif()
endif(MSVC)

if (APPLE)
   add_definitions(-D__unix__=1) #we use this for unix detection, but clang does not define it
endif(APPLE)

if (ENABLE_NEW_GAIN_BEHAVIOUR)
    add_definitions(-DNEW_GAIN_BEHAVIOUR)
endif()

########################################################################
# rpath setup - http://www.cmake.org/Wiki/CMake_RPATH_handling
########################################################################
# use, i.e. don't skip the full RPATH for the build tree
option(CMAKE_SKIP_BUILD_RPATH "skip rpath build" FALSE)

# when building, don't use the install RPATH already
# (but later on when installing)
option(CMAKE_BUILD_WITH_INSTALL_RPATH "build with install rpath" FALSE)

# the RPATH to be used when installing, but only if it's not a system directory
option(CMAKE_AUTOSET_INSTALL_RPATH "Set RPATH when installing to a non-system directory" FALSE)
if(CMAKE_AUTOSET_INSTALL_RPATH)
LIST(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}" isSystemDir)
IF("${isSystemDir}" STREQUAL "-1")
    SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}")
ENDIF("${isSystemDir}" STREQUAL "-1")
endif(CMAKE_AUTOSET_INSTALL_RPATH)

# add the automatically determined parts of the RPATH
# which point to directories outside the build tree to the install RPATH
option(CMAKE_INSTALL_RPATH_USE_LINK_PATH "build with automatic rpath" TRUE)

if(APPLE)
    set(CMAKE_MACOSX_RPATH ON)
endif()

########################################################################
## lime suite build
########################################################################
add_subdirectory(src)
add_subdirectory(mcu_program)
add_subdirectory(LimeUtil)
add_subdirectory(QuickTest)

########################################################################
## SoapySDR bindings for LMS7 RFIC driver
########################################################################
add_subdirectory(SoapyLMS7)

########################################################################
## udev rules for linux usb
########################################################################
if (DEFINED UDEV_RULES_PATH)
    install(
        FILES ${CMAKE_CURRENT_SOURCE_DIR}/udev-rules/64-limesuite.rules
        DESTINATION ${UDEV_RULES_PATH})
endif()

########################################################################
## Doxygen
########################################################################
find_package(Doxygen QUIET)
include(FeatureSummary)
include(CMakeDependentOption)
cmake_dependent_option(ENABLE_API_DOXYGEN "Enable LMS API Doxygen documentation" OFF "DOXYGEN_FOUND" OFF)
add_feature_info(LimeSuiteDocAPI ENABLE_API_DOXYGEN "LMS API Doxygen documentation")
if (ENABLE_API_DOXYGEN)
  configure_file(${CMAKE_CURRENT_SOURCE_DIR}/docs/doxygen/DoxyfileAPI.in ${CMAKE_CURRENT_BINARY_DIR}/doc/Doxyfile @ONLY)
  add_custom_target(docAPI ALL
    ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/doc/Doxyfile 
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
    COMMENT "Generating LMS API documentation with Doxygen" VERBATIM
    )
endif()

if(DOXYGEN_FOUND)
  configure_file(${CMAKE_CURRENT_SOURCE_DIR}/docs/doxygen/Doxyfile.in ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile @ONLY)
  add_custom_target(doc
    ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile 
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
    COMMENT "Generating documentation with Doxygen" VERBATIM
    )
endif()

########################################################################
# CMake Project config files
########################################################################
if (ENABLE_HEADERS AND ENABLE_LIBRARY)
    configure_file(
        ${PROJECT_SOURCE_DIR}/cmake/Modules/LimeSuiteConfigVersion.in.cmake
        ${PROJECT_BINARY_DIR}/LimeSuiteConfigVersion.cmake
    @ONLY)

    install(FILES
        ${PROJECT_SOURCE_DIR}/cmake/Modules/LimeSuiteConfig.cmake
        ${PROJECT_BINARY_DIR}/LimeSuiteConfigVersion.cmake
        DESTINATION lib${LIB_SUFFIX}/cmake/${PROJECT_NAME})
endif (ENABLE_HEADERS AND ENABLE_LIBRARY)

########################################################################
## freedesktop environment integration
########################################################################
add_subdirectory(Desktop)

########################################################################
## Octave plugin integration
########################################################################
add_subdirectory(octave)

#########################################################################
# summary
#########################################################################
include(FeatureSummary)
message(STATUS "")
message(STATUS "######################################################")
message(STATUS "## ${PROJECT_NAME} enabled features")
message(STATUS "######################################################")
feature_summary(WHAT ENABLED_FEATURES)
message(STATUS "######################################################")

=== Desktop/CMakeLists.txt ===
########################################################################
## Feature registration
########################################################################
if(CMAKE_SYSTEM_NAME STREQUAL "Linux")
    set(LINUX TRUE)
endif()

include(FeatureSummary)
include(CMakeDependentOption)
cmake_dependent_option(ENABLE_DESKTOP "Enable LimeSuite launcher and icons" ON "ENABLE_GUI;LINUX" OFF)
add_feature_info(LimeSuiteDesktop ENABLE_DESKTOP "LimeSuite freedesktop integration")
if (NOT ENABLE_DESKTOP)
    return()
endif()

########################################################################
# menu launcher and MIME type
########################################################################
file(GLOB lime_suite_png_icons ${CMAKE_CURRENT_SOURCE_DIR}/lime-suite-*.png)

install(
    FILES
        lime-suite.desktop
        ${lime_suite_png_icons}
    DESTINATION share/Lime/Desktop
)

########################################################################
# install/uninstall scripts
########################################################################
install(
    PROGRAMS
        install
        uninstall
    DESTINATION share/Lime/Desktop
)

=== LimeUtil/CMakeLists.txt ===
########################################################################
# Lime Util -- command line utility, info and connections
########################################################################
cmake_dependent_option(ENABLE_LIME_UTIL "LimeSuite device utility" ON "ENABLE_LIBRARY" OFF)
add_feature_info(LimeUtilCommand ENABLE_LIME_UTIL "Command line device discovery utility")
if(ENABLE_LIME_UTIL)
    add_executable(LimeUtil
        LimeUtil.cpp
        LimeUtilTiming.cpp
        LimeUtilCalSweep.cpp)
    target_link_libraries(LimeUtil LimeSuite)
    install(TARGETS LimeUtil DESTINATION bin)
endif()

=== src/ConnectionRegistry/CMakeLists.txt ===
set(connection_registry_src_files
    ConnectionHandle.cpp
    ConnectionRegistry.cpp
    IConnection.cpp
)

add_library(connectionRegistry STATIC ${connection_registry_src_files})
target_include_directories(connectionRegistry PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})
set_property(TARGET connectionRegistry PROPERTY POSITION_INDEPENDENT_CODE TRUE)

=== src/ConnectionRemote/CMakeLists.txt ===
########################################################################
## Support for EVB7 over COM serial connection
########################################################################

set(THIS_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/ConnectionRemote)

set(CONNECTION_REMOTE_SOURCES
    ${THIS_SOURCE_DIR}/ConnectionRemoteEntry.cpp
    ${THIS_SOURCE_DIR}/ConnectionRemote.cpp
    ${THIS_SOURCE_DIR}/LMS64CProtocol_remote.cpp
)

########################################################################
## Feature registration
########################################################################
include(FeatureSummary)
include(CMakeDependentOption)
cmake_dependent_option(ENABLE_REMOTE "Enable Remote connection" OFF "ENABLE_LIBRARY" OFF)
add_feature_info(ConnectionRemote ENABLE_REMOTE "DO NOT ENABLE. Feature is for internal development debugging only")
if (NOT ENABLE_REMOTE)
    return()
endif()
message(WARNING "ENABLE_REMOTE is only for internal debugging purposes, do not use for releases")

target_compile_definitions(LimeSuite PRIVATE -DREMOTE_CONTROL)
########################################################################
## Add to library
########################################################################
target_sources(LimeSuite PRIVATE ${CONNECTION_REMOTE_SOURCES})

if(WIN32)
target_link_libraries(LimeSuite Ws2_32.lib)
endif()

=== src/ConnectionSTREAM_UNITE/CMakeLists.txt ===
########################################################################
## Support for Stream+UNITE (USB+COM) connection
########################################################################

#if(WIN32)
#    find_package(CyAPI)
#    set(USB_FOUND ${CYAPI_FOUND})
#    set(USB_INCLUDE_DIRS ${CYAPI_INCLUDE_DIRS})
#    set(USB_LIBRARIES ${CYAPI_LIBRARIES} SetupAPI)
#elseif(UNIX)
#    find_package(libusb-1.0)
#    set(USB_FOUND ${LIBUSB_1_FOUND})
#    set(USB_INCLUDE_DIRS ${LIBUSB_1_INCLUDE_DIRS})
#    set(USB_LIBRARIES ${LIBUSB_1_LIBRARIES})
#endif()

#message(STATUS "USB_INCLUDE_DIRS: ${USB_INCLUDE_DIRS}")
#message(STATUS "USB_LIBRARIES: ${USB_LIBRARIES}")

set(THIS_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/ConnectionSTREAM_UNITE)

set(CONNECTION_STREAM_UNITE_SOURCES
    ${THIS_SOURCE_DIR}/ConnectionSTREAM_UNITEEntry.cpp
    ${THIS_SOURCE_DIR}/ConnectionSTREAM_UNITE.cpp
)

#set(CONNECTION_STREAM_UNITE_LIBRARIES ${USB_LIBRARIES})

########################################################################
## Feature registration
########################################################################
include(FeatureSummary)
include(CMakeDependentOption)
cmake_dependent_option(ENABLE_STREAM_UNITE "Enable STREAM+UNITE" ON "ENABLE_LIBRARY;ENABLE_EVB7COM;ENABLE_FX3" OFF)
add_feature_info(ConnectionSTREAM_UNITE ENABLE_STREAM_UNITE "STREAM+UNITE Connection support")
if (NOT ENABLE_STREAM_UNITE)
    return()
endif()

########################################################################
## Add to library
########################################################################
#target_include_directories(LimeSuite PUBLIC ${USB_INCLUDE_DIRS})
target_sources(LimeSuite PRIVATE ${CONNECTION_STREAM_UNITE_SOURCES})
#target_link_libraries(LimeSuite ${CONNECTION_STREAM_UNITE_LIBRARIES})

=== src/examples/CMakeLists.txt ===
include(FeatureSummary)
include(CMakeDependentOption)
cmake_dependent_option(ENABLE_EXAMPLES "Enable library example programs" ON "ENABLE_LIBRARY" OFF)
add_feature_info(LimeSuiteExamples ENABLE_EXAMPLES "LimeSuite library API examples")
if (NOT ENABLE_EXAMPLES)
    return()
endif()

if (UNIX)
find_package(Gnuplot)
if (GNUPLOT_FOUND)
add_definitions(-DUSE_GNU_PLOT)
message(STATUS "GNUPlot Found")
endif()
endif()

add_executable(basicRX basicRX.cpp)
set_target_properties(basicRX PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin")
target_link_libraries(basicRX LimeSuite)

add_executable(singleRX singleRX.cpp)
set_target_properties(singleRX PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin")
target_link_libraries(singleRX LimeSuite)

add_executable(dualRXTX dualRXTX.cpp)
set_target_properties(dualRXTX PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin")
target_link_libraries(dualRXTX LimeSuite)

add_executable(gpio_example gpio_example.cpp)
set_target_properties(gpio_example PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin")
target_link_libraries(gpio_example LimeSuite)

add_executable(basicTX basicTX.cpp)
set_target_properties(basicTX PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin")
target_link_libraries(basicTX LimeSuite)

if(ENABLE_LIMERFE)
    add_executable(limeRFE_USB_example limeRFE_USB_example.cpp)
    set_target_properties(limeRFE_USB_example PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin")
    target_link_libraries(limeRFE_USB_example LimeSuite)

    add_executable(limeRFE_I2C_example limeRFE_I2C_example.cpp)
    set_target_properties(limeRFE_I2C_example PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin")
    target_link_libraries(limeRFE_I2C_example LimeSuite)

    add_executable(limeRFE_ADC_example limeRFE_ADC_example.cpp)
    set_target_properties(limeRFE_ADC_example PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin")
    target_link_libraries(limeRFE_ADC_example LimeSuite)
endif()

=== src/limeRFE/CMakeLists.txt ===
########################################################################
## Support for LimeRFE
########################################################################
set(THIS_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR})
set(LIMERFE_GUI_SOURCES
    ${THIS_SOURCE_DIR}/limeRFE_gui.cpp
    ${THIS_SOURCE_DIR}/limeRFE_wxgui.cpp
    ${THIS_SOURCE_DIR}/limeRFE_cmd.cpp
    ${THIS_SOURCE_DIR}/RFE_Device.cpp
)
#milans 200309
#if(MSVC)
#    list(APPEND LIMERFE_GUI_SOURCES ${THIS_SOURCE_DIR}/external/termiWin/termiWin.c)
#endif()

set(LIMERFE_SOURCES
    ${THIS_SOURCE_DIR}/limeRFE_cmd.cpp
    ${THIS_SOURCE_DIR}/limeRFE_api.cpp
    ${THIS_SOURCE_DIR}/RFE_Device.cpp
)

#milans 200309
#if(MSVC)
#    list(APPEND LIMERFE_SOURCES ${THIS_SOURCE_DIR}/external/termiWin/termiWin.c)
#endif()

########################################################################
## Feature registration
########################################################################
include(FeatureSummary)
include(CMakeDependentOption)
cmake_dependent_option(ENABLE_LIMERFE "Enable LimeRFE support" ON "ENABLE_LIBRARY" OFF)
add_feature_info(LimeRFE ENABLE_LIMERFE "LimeRFE support")

if(ENABLE_LIMERFE AND ENABLE_GUI)
    target_compile_definitions(LimeSuiteGUI PUBLIC "LIMERFE")
endif()

if (NOT ENABLE_LIMERFE)
    return()
endif()

########################################################################
## Add to library
########################################################################
if(ENABLE_GUI)
    target_sources(LimeSuiteGUI PRIVATE ${LIMERFE_GUI_SOURCES})
endif()
target_sources(LimeSuite PRIVATE ${LIMERFE_SOURCES})

=== debian/changelog ===
limesuite (23.11.0) unstable; urgency=medium

  * Automatically generated changelog entry for building the Osmocom latest feed

 -- Osmocom OBS scripts <info@osmocom.org>  Mon, 20 Nov 2023 20:54:55 +0000

limesuite (23.11.0-1) unstable; urgency=low

  * Release 23.11.0 (2023-11-19)

 -- Lime Microsystems <apps@limemicro.com>  Sat, 15 Oct 2022 16:30:00 +0100

=== debian/control ===
--- 
+++ 
@@ -16,7 +16,7 @@
 Vcs-Git: https://github.com/myriadrf/LimeSuite.git
 Vcs-Browser: https://github.com/myriadrf/LimeSuite.git
 
-Package: liblimesuite23.10-1
+Package: liblimesuite23.11-1
 Section: libs
 Architecture: any
 Multi-Arch: same
@@ -30,7 +30,7 @@
 Section: libdevel
 Architecture: any
 Depends:
-    liblimesuite23.10-1 (= ${binary:Version}),
+    liblimesuite23.11-1 (= ${binary:Version}),
     ${misc:Depends}
 Description: Lime Suite - development files
  Lime Suite application software.
@@ -39,7 +39,7 @@
 Section: comm
 Architecture: any
 Depends:
-    liblimesuite23.10-1 (= ${binary:Version}),
+    liblimesuite23.11-1 (= ${binary:Version}),
     ${shlibs:Depends},
     ${misc:Depends},
     xdg-utils
@@ -59,7 +59,7 @@
 Architecture: any
 Multi-Arch: same
 Depends:
-    liblimesuite23.10-1 (= ${binary:Version}),
+    liblimesuite23.11-1 (= ${binary:Version}),
     ${shlibs:Depends},
     ${misc:Depends}
 Description: Lime Suite - SoapySDR bindings
@@ -73,7 +73,7 @@
 Description: Lime Suite - USB rules for udev
  Lime Suite application software.
 
-Package: limesuite-images23.10
+Package: limesuite-images23.11
 Section: libs
 Architecture: any
 Multi-Arch: same
@@ -87,7 +87,7 @@
 Section: libs
 Architecture: any
 Multi-Arch: same
-Depends: ${shlibs:Depends}, ${misc:Depends}, limesuite-images23.10
+Depends: ${shlibs:Depends}, ${misc:Depends}, limesuite-images23.11
 Description: Lime Suite - Install firmware and gateware images
  Lime Suite application software.
  .

## limesuite 23.11.0%2Bdfsg

=== src/CMakeLists.txt ===
########################################################################
## public headers
########################################################################
set(LIME_SUITE_PUBLIC_HEADERS
    lime/LimeSuite.h
    VersionInfo.h
    Logger.h
    SystemResources.h
    LimeSuiteConfig.h
    ADF4002/ADF4002.h
    lms7002m_mcu/MCU_BD.h
    lms7002m_mcu/MCU_File.h
    ConnectionRegistry/IConnection.h
    ConnectionRegistry/ConnectionHandle.h
    ConnectionRegistry/ConnectionRegistry.h
    lms7002m/LMS7002M.h
    lms7002m/LMS7002M_RegistersMap.h
    lime/LMS7002M_parameters.h
    protocols/Streamer.h
    protocols/ADCUnits.h
    protocols/LMS64CCommands.h
    protocols/LMS64CProtocol.h
    protocols/LMSBoards.h
    protocols/dataTypes.h
    protocols/fifo.h
    Si5351C/Si5351C.h
    FPGA_common/FPGA_common.h
    API/lms7_device.h
    limeRFE/limeRFE.h
)

include(FeatureSummary)
include(CMakeDependentOption)
cmake_dependent_option(ENABLE_HEADERS "Enable install headers" ON "TRUE" OFF)
add_feature_info(LimeSuiteHeaders ENABLE_HEADERS "The lime suite headers")
if (ENABLE_HEADERS)
    install(
        FILES ${LIME_SUITE_PUBLIC_HEADERS}
        DESTINATION include/lime
    )
endif()

########################################################################
## lime suite library
########################################################################
set(LIME_SUITE_SOURCES
    Logger.cpp
    ADF4002/ADF4002.cpp
    lms7002m_mcu/MCU_BD.cpp
    lms7002m_mcu/MCU_File.cpp
    ConnectionRegistry/IConnection.cpp
    ConnectionRegistry/ConnectionHandle.cpp
    ConnectionRegistry/ConnectionRegistry.cpp
    lms7002m/LMS7002M_RegistersMap.cpp
    lms7002m/LMS7002M_parameters.cpp
    lms7002m/LMS7002M.cpp
    lms7002m/LMS7002M_RxTxCalibrations.cpp
    lms7002m/LMS7002M_BaseCalibrations.cpp
    lms7002m/mcu_dc_iq_calibration.cpp
    lms7002m/LMS7002M_filtersCalibration.cpp
    lms7002m/LMS7002M_gainCalibrations.cpp
    protocols/LMS64CProtocol.cpp
    protocols/Streamer.cpp
    protocols/ConnectionImages.cpp
    Si5351C/Si5351C.cpp
    ${PROJECT_SOURCE_DIR}/external/kissFFT/kiss_fft.c
    API/lms7_api.cpp
    API/lms7_device.cpp
    API/LmsGeneric.cpp
    API/qLimeSDR.cpp
    API/LimeSDR_mini.cpp
    API/LimeSDR.cpp
    API/LimeNET_micro.cpp
    API/LimeSDR_PCIE.cpp
    API/LimeSDR_Core.cpp
    FPGA_common/FPGA_common.cpp
    FPGA_common/FPGA_Mini.cpp
    FPGA_common/FPGA_Q.cpp
    windowFunction.cpp
    threadHelper/threadHelper.cpp
)

set(LIME_SUITE_INCLUDES
    ${CMAKE_CURRENT_SOURCE_DIR}
    API
    lime
    GFIR
    protocols
    ConnectionRegistry
    lms7002m_mcu
    ADF4002
    Si5351C
    lms7002m
    FPGA_common
    lms7002m_mcu
    ${PROJECT_SOURCE_DIR}/external/cpp-feather-ini-parser
    ${PROJECT_SOURCE_DIR}/external/kissFFT/
    limeRFE
    threadHelper
)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/VersionInfo.in.cpp
    ${CMAKE_CURRENT_BINARY_DIR}/VersionInfo.cpp @ONLY)
list(APPEND LIME_SUITE_SOURCES ${CMAKE_CURRENT_BINARY_DIR}/VersionInfo.cpp)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/SystemResources.in.cpp
    ${CMAKE_CURRENT_BINARY_DIR}/SystemResources.cpp @ONLY)
list(APPEND LIME_SUITE_SOURCES ${CMAKE_CURRENT_BINARY_DIR}/SystemResources.cpp)

set(CMAKE_THREAD_PREFER_PTHREAD TRUE)
set(THREADS_PREFER_PTHREAD_FLAG TRUE)
find_package(Threads REQUIRED)
list(APPEND LIME_SUITE_LIBRARIES Threads::Threads)

include(CheckAtomic)
if(NOT HAVE_CXX_ATOMICS_WITHOUT_LIB OR NOT HAVE_CXX_ATOMICS64_WITHOUT_LIB)
    list(APPEND LIME_SUITE_LIBRARIES atomic)
endif()

include(FeatureSummary)
include(CMakeDependentOption)

option(ENABLE_LIBRARY "Enable build library" ON)
add_feature_info(LimeSuiteLibrary ENABLE_LIBRARY "The lime suite library")
if (ENABLE_LIBRARY)
    add_library(LimeSuite ${LIME_SUITE_SOURCES})
    target_link_libraries(LimeSuite ${LIME_SUITE_LIBRARIES})
    set_property(TARGET LimeSuite PROPERTY POSITION_INDEPENDENT_CODE TRUE)
    set_target_properties(LimeSuite PROPERTIES SOVERSION ${LIME_SUITE_SOVER})
    set_target_properties(LimeSuite PROPERTIES VERSION ${LIME_SUITE_LIBVER})
    set_target_properties(LimeSuite PROPERTIES DEFINE_SYMBOL "LIME_DLL_EXPORTS")
    target_include_directories(LimeSuite PUBLIC ${LIME_SUITE_INCLUDES})

    if(BUILD_SHARED_LIBS)
        target_compile_definitions(LimeSuite PUBLIC "LIME_DLL")
    endif()

    install(TARGETS LimeSuite
        LIBRARY DESTINATION lib${LIB_SUFFIX} # .so file
        ARCHIVE DESTINATION lib${LIB_SUFFIX} # .lib file
        RUNTIME DESTINATION bin              # .dll file
    )

	if (MSVC)
		set_target_properties(LimeSuite PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin")
	endif(MSVC)

    add_subdirectory(GFIR)
    set(LIME_SUITE_LIBS LimeSuite)
endif()

########################################################################
## Supported connections
########################################################################
include(ConnectionEVB7COM/CMakeLists.txt)
include(ConnectionFX3/CMakeLists.txt)
include(ConnectionSTREAM_UNITE/CMakeLists.txt)
include(ConnectionFTDI/CMakeLists.txt)
include(ConnectionXillybus/CMakeLists.txt)
include(ConnectionSPI/CMakeLists.txt)

## Remote connection is not safe or efficient, it should not be in releases (github #263)
## it's only for debugging purposes when USB device cannot be used by multiple applications simultaneously.
#include(ConnectionRemote/CMakeLists.txt)

configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/ConnectionRegistry/BuiltinConnections.in.cpp
    ${CMAKE_CURRENT_BINARY_DIR}/BuiltinConnections.cpp
)

target_sources(LimeSuite PRIVATE ${CMAKE_CURRENT_BINARY_DIR}/BuiltinConnections.cpp)

########################################################################
## wx widgets dependency
########################################################################
set(wxWidgets_USE_DEBUG OFF)
set(wxWidgets_USE_UNICODE ON)
set(wxWidgets_USE_UNIVERSAL OFF)
set(wxWidgets_USE_STATIC ON)
find_package(wxWidgets COMPONENTS richtext xml html xrc adv aui core base gl)
message(STATUS "wxWidgets_DEFINITIONS: ${wxWidgets_DEFINITIONS}")
message(STATUS "wxWidgets_INCLUDE_DIRS: ${wxWidgets_INCLUDE_DIRS}")
message(STATUS "wxWidgets_LIBRARIES: ${wxWidgets_LIBRARIES}")

########################################################################
## LimeSuite GUI app
########################################################################
set(LMS7SUITE_GUI_SOURCES
    ADF4002/ADF4002_wxgui.cpp
    lms7002_wxgui/lms7002_pnlXBUF_view.cpp
    lms7002_wxgui/lms7002_pnlRFE_view.cpp
    lms7002_wxgui/lms7002_pnlCalibrations_view.cpp
    lms7002_wxgui/lms7002_pnlTRF_view.cpp
    lms7002_wxgui/lms7002_pnlCDS_view.cpp
    lms7002_wxgui/lms7002_pnlLimeLightPAD_view.cpp
    lms7002_wxgui/lms7002_pnlBIST_view.cpp
    lms7002_wxgui/dlgViewIRAM.cpp
    lms7002_wxgui/lms7002_gui_utilities.cpp
    lms7002_wxgui/lms7002_pnlSX_view.cpp
    lms7002_wxgui/lms7002_pnlTBB_view.cpp
    lms7002_wxgui/lms7002_dlgVCOfrequencies.cpp
    lms7002_wxgui/lms7002_pnlRBB_view.cpp
    lms7002_wxgui/lms7002_pnlLDO_view.cpp
    lms7002_wxgui/lms7002_pnlAFE_view.cpp
    lms7002_wxgui/lms7002_pnlGains_view.cpp
    lms7002_wxgui/CoefficientFileParser.cpp
    lms7002_wxgui/lms7002_pnlRxTSP_view.cpp
    lms7002_wxgui/lms7002_mainPanel.cpp
    lms7002_wxgui/dlgViewSFR.cpp
    lms7002_wxgui/lms7002_pnlCLKGEN_view.cpp
    lms7002_wxgui/lms7002_pnlMCU_BD_view.cpp
    lms7002_wxgui/lms7002_pnlBIAS_view.cpp
    lms7002_wxgui/lms7002_dlgGFIR_Coefficients.cpp
    lms7002_wxgui/lms7002_pnlTxTSP_view.cpp
    lms7002_wxgui/lms7002_pnlR3.cpp
    LMS_Programing/LMS_Programing_wxgui.cpp
    utilities_gui/dlgConnectionSettings.cpp
    utilities_gui/pnlMiniLog.cpp
    utilities_gui/pnlAPI.cpp
    utilities_gui/SPI_wxgui.cpp
    utilities_gui/dlgFullMessageLog.cpp
    utilities_gui/dlgDeviceInfo.cpp
    utilities_gui/utilities_gui.cpp
    lms7suiteAppFrame.cpp
    boards_wxgui/RFSpark_wxgui.cpp
    Si5351C/Si5351C_wxgui.cpp
    lms7suiteApp_gui.cpp
    lms7suiteApp.cpp
    FPGAcontrols_wxgui/FPGAcontrols_wxgui.cpp
    dlgAbout.cpp
    numericSlider/numericSlider.cpp
    fftviewer_wxgui/fftviewer_wxgui.cpp
    fftviewer_wxgui/fftviewer_frFFTviewer.cpp
    lms7suiteEvents/lms7suiteEvents.cpp
    boards_wxgui/pnlBoardControls.cpp
    boards_wxgui/pnlQSpark.cpp
    boards_wxgui/pnluLimeSDR.cpp
    boards_wxgui/pnlUltimateEVB.cpp
    boards_wxgui/pnlBuffers.cpp
    boards_wxgui/pnlCoreSDR.cpp
    boards_wxgui/pnlLimeNetMicro.cpp
    ${PROJECT_SOURCE_DIR}/external/kissFFT/kiss_fft.c
    windowFunction.cpp
    boards_wxgui/pnlLimeSDR.cpp
    boards_wxgui/pnlGPIO.cpp
)

include(FeatureSummary)
include(CMakeDependentOption)
cmake_dependent_option(ENABLE_GUI "Enable build GUI" ON "ENABLE_LIBRARY;wxWidgets_FOUND" OFF)
add_feature_info(LimeSuiteGUI ENABLE_GUI "GUI Application for LimeSuite")
if (ENABLE_GUI)

    include_directories(lms7002_wxgui)
    include_directories(LMS_Programing)
    include_directories(utilities_gui)
    include_directories(RFSpark)
    include_directories(FPGAcontrols_wxgui)
    include_directories(numericSlider)
    include_directories(fftviewer_wxgui)
    include_directories(lms7suiteEvents)
    include_directories(boards_wxgui)
    include_directories(limeRFE)

    include(${wxWidgets_USE_FILE})
    add_subdirectory(oglGraph)

    set(BINARY_OUTPUT_DIR "${CMAKE_BINARY_DIR}/bin")

    add_executable(LimeSuiteGUI ${LMS7SUITE_GUI_SOURCES} resources/resource.rc)
    set_target_properties(LimeSuiteGUI PROPERTIES
        RUNTIME_OUTPUT_DIRECTORY ${BINARY_OUTPUT_DIR})
    target_compile_definitions(LimeSuiteGUI PRIVATE WIN32_LEAN_AND_MEAN)

    target_link_libraries(LimeSuiteGUI LimeSuite oglGraph ${wxWidgets_LIBRARIES})

    if (MSVC)
        set_property(TARGET LimeSuiteGUI APPEND PROPERTY LINK_FLAGS /SUBSYSTEM:WINDOWS)
    endif(MSVC)

    install(TARGETS LimeSuiteGUI DESTINATION bin)

endif()

########################################################################
# Build pkg config file
########################################################################
if (ENABLE_HEADERS AND ENABLE_LIBRARY)
configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/LimeSuite.pc.in
    ${CMAKE_CURRENT_BINARY_DIR}/LimeSuite.pc
@ONLY)

install(
    FILES ${CMAKE_CURRENT_BINARY_DIR}/LimeSuite.pc
    DESTINATION lib${LIB_SUFFIX}/pkgconfig
)
endif (ENABLE_HEADERS AND ENABLE_LIBRARY)

#########################################################################
# utilities
#########################################################################
add_subdirectory(utilities)

#########################################################################
# examples
#########################################################################
add_subdirectory(examples)

#########################################################################
# LimeRFE
#########################################################################
add_subdirectory(limeRFE)

## limesuite 23.11.0+dfsg

=== octave/CMakeLists.txt ===
# LimeSuite Octave plugin compilation
########################################################################
## Feature registration
########################################################################
find_program(OCTAVE_CONFIG_EXECUTABLE NAMES octave-config)
if(NOT OCTAVE_CONFIG_EXECUTABLE)
    message(STATUS "octave-config not found (need liboctave-dev), disabling LimeSuiteOctave")
else()
    execute_process (COMMAND ${OCTAVE_CONFIG_EXECUTABLE} -p BINDIR OUTPUT_VARIABLE OCTAVE_BIN_PATHS OUTPUT_STRIP_TRAILING_WHITESPACE)
    find_program(OCTAVE_MKOCTFILE_EXECUTABLE HINTS ${OCTAVE_BIN_PATHS} NAMES mkoctfile)
endif()

include(FeatureSummary)
include(CMakeDependentOption)
cmake_dependent_option(ENABLE_OCTAVE "Enable LimeSuite library plugin for Octave" ON "ENABLE_LIBRARY;OCTAVE_CONFIG_EXECUTABLE;OCTAVE_MKOCTFILE_EXECUTABLE" OFF)
add_feature_info(LimeSuiteOctave ENABLE_OCTAVE "LimeSuite Octave integration")

if (NOT ENABLE_OCTAVE)
    return()
endif()

add_custom_command(OUTPUT LimeSuite.oct LimeSuite.o
    ALL
    COMMAND ${OCTAVE_MKOCTFILE_EXECUTABLE}
    ARGS -I${PROJECT_SOURCE_DIR}/src/lime ${CMAKE_CURRENT_SOURCE_DIR}/LimeSuite.cc -L$<TARGET_FILE_DIR:LimeSuite> -lLimeSuite
    COMMENT "Building LimeSuite Octave plugin"
    DEPENDS LimeSuite
)
add_custom_target(LimeSuiteOctave ALL DEPENDS LimeSuite.oct)

#install script for preloading Limesuite.oct functions
execute_process (COMMAND ${OCTAVE_CONFIG_EXECUTABLE} --m-site-dir
    OUTPUT_VARIABLE OCTAVE_SCRIPTS_PATHS OUTPUT_STRIP_TRAILING_WHITESPACE)
install(
    FILES
        ${CMAKE_CURRENT_SOURCE_DIR}/LoadLimeSuite.m
    DESTINATION ${OCTAVE_SCRIPTS_PATHS}
)

#install dynamic library
execute_process (COMMAND ${OCTAVE_CONFIG_EXECUTABLE} --oct-site-dir
    OUTPUT_VARIABLE OCTAVE_LIBS_PATHS OUTPUT_STRIP_TRAILING_WHITESPACE)
install(
    FILES
        ${CMAKE_CURRENT_BINARY_DIR}/LimeSuite.oct
    DESTINATION ${OCTAVE_LIBS_PATHS}
)

=== src/ConnectionSPI/CMakeLists.txt ===
########################################################################
## Support for Rasp Pi 3 SPI connection
########################################################################
set(THIS_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/ConnectionSPI)

set(CONNECTION_SPI_SOURCES
    ${THIS_SOURCE_DIR}/ConnectionSPIEntry.cpp
    ${THIS_SOURCE_DIR}/ConnectionSPI.cpp
)

CHECK_INCLUDE_FILE("wiringPi.h" HAS_WIRING_HEADER)

########################################################################
## Feature registration
########################################################################
include(FeatureSummary)
include(CMakeDependentOption)
cmake_dependent_option(ENABLE_SPI "Enable SPI connection" OFF "ENABLE_LIBRARY;HAS_WIRING_HEADER" OFF)
add_feature_info(ConnectionSPI ENABLE_SPI "Rasp Pi 3 SPI Connection support")
if (NOT ENABLE_SPI)
    return()
endif()

########################################################################
## Add to library
########################################################################
target_sources(LimeSuite PRIVATE ${CONNECTION_SPI_SOURCES})
target_link_libraries(LimeSuite wiringPi crypt)

=== debian/changelog ===
limesuite (23.11.0+dfsg-4) unstable; urgency=medium

  * Fix FTBFS with gcc-15. (Closes: #1097297)
  * Fix FTBFS with cmake-4. (Closes: #1113231)

 -- Christoph Berg <myon@debian.org>  Wed, 10 Sep 2025 16:59:04 +0000

limesuite (23.11.0+dfsg-3) unstable; urgency=medium

  * Team upload.

  * Replaced obsolete build dependency pkg-config with pkgconf.
  * Added Appstream metainfo announcing hardware support.
  * Trimmed path globs in d/copyright.  Thanks Lintian.
  * Updated Standards-Version from 4.6.0 to 4.7.0.
  * Added d/gbp.conf to enforce use of pristine-tar.

 -- Petter Reinholdtsen <pere@debian.org>  Sat, 27 Apr 2024 11:31:55 +0200

limesuite (23.11.0+dfsg-2) unstable; urgency=medium

  * Source-only upload.

 -- Christoph Berg <myon@debian.org>  Sat, 25 Nov 2023 11:19:23 +0000

limesuite (23.11.0+dfsg-1) unstable; urgency=medium

  * New upstream version 23.11.0+dfsg.
  * Move 64-limesuite.rules to /usr/lib/udev/rules.d/.

 -- Christoph Berg <myon@debian.org>  Thu, 23 Nov 2023 15:30:42 +0000

limesuite (22.09.1+dfsg-2) unstable; urgency=medium

  * Team upload.
  * Fix FTBFS with GCC-13 (Closes: #1037754)

 -- tony mancill <tmancill@debian.org>  Sat, 15 Jul 2023 13:08:16 -0700

=== debian/control ===
Source: limesuite
Section: hamradio
Priority: optional
Maintainer: Debian Hamradio Maintainers <debian-hams@lists.debian.org>
Uploaders: Andreas Bombe <aeb@debian.org>,
           Christoph Berg <myon@debian.org>,
Build-Depends: debhelper-compat (= 13),
               cmake,
               pkgconf,
               doxygen,
               libusb-1.0-0-dev,
               libwxgtk3.2-dev,
               libsoapysdr0.8-dev,
               fluid,
               freeglut3-dev,
               libglew-dev,
               libfltk1.3-dev,
Standards-Version: 4.7.0
Homepage: https://myriadrf.org/projects/lime-suite/
Vcs-Browser: https://salsa.debian.org/debian-hamradio-team/limesuite
Vcs-Git: https://salsa.debian.org/debian-hamradio-team/limesuite.git
Rules-Requires-Root: no

Package: limesuite
Architecture: any
Depends: liblimesuite23.11-1 (>= ${binary:Version}),
         python3, python3-soapysdr,
         ${shlibs:Depends}, ${misc:Depends}
Description: tools to test, control and update LMS7 transceiver based hardware
 Lime Suite is a collection of software supporting Lime Microsystems LMS7 RF
 transceiver based hardware such as the LimeSDR, LMS7002M UNITE board, or the
 Novena with LMS7 RF board.
 .
 This package contains the command line and GUI tools to control and update the
 hardware devices.

Package: liblimesuite23.11-1
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: limesuite-udev [linux-any]
Description: library to access LMS7 transceiver based hardware
 Lime Suite is a collection of software supporting Lime Microsystems LMS7 RF
 transceiver based hardware such as the LimeSDR, LMS7002M UNITE board, or the
 Novena with LMS7 RF board.
 .
 This package contains the shared library to access LMS7 based hardware.

Package: liblimesuite-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: liblimesuite23.11-1 (= ${binary:Version}),
         ${misc:Depends}
Suggests: liblimesuite-doc
Description: library to access LMS7 transceiver based hardware (development)
 Lime Suite is a collection of software supporting Lime Microsystems LMS7 RF
 transceiver based hardware such as the LimeSDR, LMS7002M UNITE board, or the
 Novena with LMS7 RF board.
 .
 This package contains the development files for liblimesuite.

Package: liblimesuite-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: liblimesuite development documentation
 Lime Suite is a collection of software supporting Lime Microsystems LMS7 RF
 transceiver based hardware such as the LimeSDR, LMS7002M UNITE board, or the
 Novena with LMS7 RF board.
 .
 This package contains the development documentation for liblimesuite.

Package: soapysdr0.8-module-lms7
Architecture: any
Multi-Arch: same
Depends: liblimesuite23.11-1 (>= ${binary:Version}),
         ${shlibs:Depends}, ${misc:Depends}
Description: Lime Microsystems LMS7 device support for SoapySDR
 Lime Suite is a collection of software supporting Lime Microsystems LMS7 RF
 transceiver based hardware such as the LimeSDR, LMS7002M UNITE board, or the
 Novena with LMS7 RF board.
 .
 This package contains a SoapySDR module to use LMS7 based hardware to transmit
 and receive.

Package: soapysdr-module-lms7
Architecture: any
Multi-Arch: same
Depends: soapysdr0.8-module-lms7, ${misc:Depends}
Description: Lime Microsystems LMS7 device support for SoapySDR (default version)
 Lime Suite is a collection of software supporting Lime Microsystems LMS7 RF
 transceiver based hardware such as the LimeSDR, LMS7002M UNITE board, or the
 Novena with LMS7 RF board.
 .
 This is an empty dependency package that pulls in the LMS7 support module for
 the default version of libsoapysdr.

Package: limesuite-udev
Section: libs
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Lime Suite - USB rules for udev
 Lime Suite is a collection of software supporting Lime Microsystems LMS7 RF
 transceiver based hardware such as the LimeSDR, LMS7002M UNITE board, or the
 Novena with LMS7 RF board.
 .
 This package contains the udev rules to make LMS7 based hardware accessible to
 users in the plugdev group.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# for definition of DEB_VERSION
include /usr/share/dpkg/pkg-info.mk

# extract the architecture for setting the library path suffix
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- \
		-DENABLE_SIMD_FLAGS=none \
		-DBUILD_SHARED_LIBS=ON \
		-DCMAKE_AUTOSET_INSTALL_RPATH=FALSE \
		-DUDEV_RULES_PATH=/usr/lib/udev/rules.d \
		-DLIB_SUFFIX="/$(DEB_HOST_MULTIARCH)" \
		-DOVERRIDE_LIME_SUITE_VERSION="$(DEB_VERSION)"

override_dh_installdocs:
	dh_installdocs -p soapysdr-module-lms7 \
                --link-doc=soapysdr0.8-module-lms7
	dh_installdocs --remaining-packages


# Exempt a *.bak file that snuck into an upstream release from cleaning.
override_dh_clean:
	dh_clean -XlimeRFE.fbp.bak

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%limesuite-$1.tar.gz%, \
      dversionmangle=s/\+dfsg$//, repacksuffix=+dfsg" \
https://github.com/myriadrf/LimeSuite/tags .*/v([\d\.]+)\.tar\.gz

## limesuite 23.11.0.1.2141.9dce.202408012026

=== debian/changelog ===
limesuite (23.11.0.1.2141.9dce.202408012026) unstable; urgency=medium

  * Automatically generated changelog entry for building the Osmocom nightly feed

 -- Osmocom OBS scripts <info@osmocom.org>  Thu, 01 Aug 2024 20:27:38 +0000

## limesuite 23.11.0.1.2141.9dce.202408022026

=== debian/changelog ===
limesuite (23.11.0.1.2141.9dce.202408022026) unstable; urgency=medium

  * Automatically generated changelog entry for building the Osmocom nightly feed

 -- Osmocom OBS scripts <info@osmocom.org>  Fri, 02 Aug 2024 20:27:41 +0000

## limesuite 23.11.0.1.2141.9dce.202408032026

=== debian/changelog ===
limesuite (23.11.0.1.2141.9dce.202408032026) unstable; urgency=medium

  * Automatically generated changelog entry for building the Osmocom nightly feed

 -- Osmocom OBS scripts <info@osmocom.org>  Sat, 03 Aug 2024 20:27:42 +0000
